Index: issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp
===================================================================
--- issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/gsl/DenseGslSolve.cpp	(revision 23394)
@@ -14,4 +14,5 @@
 #include "../../classes/Params/Parameters.h"
 #include "../adolc/adolcincludes.h"
+#include "../codipack/codipackincludes.h"
 #include "./gslincludes.h"
 
@@ -251,2 +252,149 @@
 /*}}}*/
 #endif
+
+#ifdef _HAVE_CODIPACK_
+void SolverxSeq_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+
+	/*recast data_in and tape*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+	//IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
+	IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+
+  IssmDouble::Real* valueATrans;
+  IssmDouble::GradientData* indexATrans;
+  IssmDouble::GradientData* indexB;
+  IssmDouble::Real* valueX;
+  IssmDouble::GradientData* indexX;
+  int n;
+
+  data->getData(valueATrans);
+  data->getData(indexATrans);
+  data->getData(indexB);
+  data->getData(valueX);
+  data->getData(indexX);
+  data->getData(n);
+
+
+  // create the adjoint vector for x and reset the adjoint values on the tape
+  IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
+  getVectorAdjoint(tape, indexX, adjX, n);
+
+  IssmDouble::GradientValue* sol  = xNew<IssmDouble::GradientValue>(n);
+  SolverxSeq(sol, valueATrans, adjX, n);
+
+  updateVectorAdjoint(tape, indexB, sol, n);
+  for(int i=0; i<n; ++i) {
+    for (int j=0; j<n; ++j) {
+      // we access the transposed matrix here because we stored the indices in a transposed way
+      updateAdjoint(tape, indexATrans[i*n+j], -sol[j]*valueX[i]);
+    }
+  }
+
+  xDelete(sol);
+  xDelete(adjX);
+}
+/*}}}*/
+void SolverxSeq_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+
+	/*recast data_in*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+
+  IssmDouble::Real* valueATrans;
+  IssmDouble::GradientData* indexATrans;
+  IssmDouble::GradientData* indexB;
+  IssmDouble::Real* valueX;
+  IssmDouble::GradientData* indexX;
+  int n;
+
+  data->getData(valueATrans);
+  data->getData(indexATrans);
+  data->getData(indexB);
+  data->getData(valueX);
+  data->getData(indexX);
+  data->getData(n);
+
+  xDelete(valueATrans);
+  xDelete(indexATrans);
+  xDelete(indexB);
+  xDelete(valueX);
+  xDelete(indexX);
+}
+/*}}}*/
+void SolverxSeq(IssmDouble *X,IssmDouble *A,IssmDouble *B,int n, Parameters* parameters){/*{{{*/
+  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+  codi::DataStore* dataHandler = NULL;
+
+  if(tape.isActive()) {
+    dataHandler = new codi::DataStore();
+
+    // create the index vector and the double data for A and B
+    IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(n*n);
+    IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(n*n);
+
+    // read the data for matrix in a transposed fashion
+	  for (int i=0; i<n; ++i) {
+      for (int j=0; j<n; ++j) {
+        getPrimalAndGradData(A[i*n+j], valueATrans[j*n+i], indexATrans[j*n+i]);
+      }
+    }
+
+    // read the data from B (primal values are not required vor B
+    IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+    getVectorGradData(B, indexB, n);
+
+    dataHandler->addData(valueATrans);
+    dataHandler->addData(indexATrans);
+    dataHandler->addData(indexB);
+  }
+
+  // unpack the primal values from the matrix and the vector
+  IssmDouble::Real* valueA = xNew<IssmDouble::Real>(n*n);
+  IssmDouble::Real* valueB = xNew<IssmDouble::Real>(n);
+  // read the data from A and B
+  getVectorPrimal(A, valueA, n*n);
+  getVectorPrimal(B, valueB, n);
+
+  // create the placeholder for X and solve the system
+  IssmDouble::Real* valueX = xNew<IssmDouble::Real>(n);
+  SolverxSeq(valueX, valueA, valueB, n);
+
+  // pack the values into x
+  setVectorPrimal(X, valueX, n);
+
+  if(tape.isActive()) {
+    // create the index vector X and register x as active variables
+    IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+    registerVector(X, indexX, n);
+
+    dataHandler->addData(valueX);
+    dataHandler->addData(indexX);
+
+    // store other arguments
+    dataHandler->addData(n);
+
+    tape.pushExternalFunctionHandle(&SolverxSeq_codi_b, dataHandler, &SolverxSeq_codi_delete);
+  } else {
+    // if the tape is active valueX is stored in the dataHandler and deleted in the reverse sweep
+    xDelete(valueX);
+  }
+
+  xDelete(valueB);
+  xDelete(valueA);
+}
+/*}}}*/
+void DenseGslSolve(/*output*/ IssmDouble** px,/*stiffness matrix:*/ IssmDouble* Kff, int Kff_M, int Kff_N, /*right hand side load vector: */ IssmDouble* pf, int pf_M, Parameters* parameters){ /*{{{*/
+
+	/*Intermediary: */
+
+	if(Kff_N!=pf_M)_error_("Right hand side vector of size " << pf_M << ", when matrix is of size " << Kff_M << "-" << Kff_N << " !");
+	if(Kff_M!=Kff_N)_error_("Stiffness matrix should be square!");
+
+	IssmDouble *x  = xNew<IssmDouble>(Kff_N,"t");
+
+	SolverxSeq(x,Kff,pf,Kff_N,parameters);
+
+	/*allocate output pointers: */
+	*px=x;
+}
+/*}}}*/
+#endif
Index: issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp
===================================================================
--- issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/issm/IssmToolkitUtils.cpp	(revision 23394)
@@ -86,16 +86,15 @@
 int IssmSolverTypeFromToolkitOptions(void){ /*{{{*/
 
-	char* solver_type=NULL;
 	int   solver_type_enum;
-	int   num_procs=0;
 	bool  isparallel=false;
 
 	/*first, figure out if we are running in parallel: */
-	num_procs=IssmComm::GetSize();
+	int num_procs=IssmComm::GetSize();
 	if(num_procs>1)isparallel=true;
 
 	/*retrieve solver type as a string, from the Toolkits Options database, similar to what Petsc does. Actually, 
 	 *we try and stick with the Petsc vector types: */
-	solver_type=ToolkitOptions::GetToolkitOptionValue("solver_type");
+	char* solver_type=ToolkitOptions::GetToolkitOptionValue("solver_type");
+	if(!solver_type) _error_("Solver not set");
 
 	if (strcmp(solver_type,"mumps")==0){
Index: issm/trunk/src/c/toolkits/mpi/issmmpi.cpp
===================================================================
--- issm/trunk/src/c/toolkits/mpi/issmmpi.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/mpi/issmmpi.cpp	(revision 23394)
@@ -42,5 +42,5 @@
   assert(sendcount==recvcount || sendtype==recvtype); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Allgather(sendbuf,
 		    sendcount,
@@ -60,5 +60,5 @@
 # endif
 #else
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -76,5 +76,5 @@
   assert(sendtype==recvtype); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Allgatherv(sendbuf,
 		     sendcount,
@@ -97,5 +97,5 @@
 #else
   assert(sendcount==recvcounts[0]); // we handle only identical representations 
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -113,5 +113,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Allreduce(sendbuf,
 		    recvbuf,
@@ -129,5 +129,5 @@
 # endif
 #else
-# ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
   if (datatype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -145,5 +145,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Barrier(comm);
 # else 
@@ -159,5 +159,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Bcast(buffer, 
 		count,
@@ -181,5 +181,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   assert(0); // to be implemented
 # else 
@@ -215,12 +215,19 @@
 int ISSM_MPI_Finalize(void){  /*{{{*/
 
-  int rc=0;
-#ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
-  rc=AMPI_Finalize_NT();
-# else
-  rc=MPI_Finalize();
-# endif
-#endif
+	int rc=0;
+	#ifdef _HAVE_MPI_
+		#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
+			#if defined(_HAVE_ADJOINTMPI_)
+				rc=AMPI_Finalize();
+			#elif defined(_HAVE_MEDIPACK_)
+				TOOL::finalize();
+				rc=AMPI_Finalize();
+			#else
+				rc=AMPI_Finalize_NT();
+			#endif
+		#else
+		  rc=MPI_Finalize();
+		#endif
+	#endif
   return rc;
 }/*}}}*/
@@ -230,5 +237,5 @@
   assert(sendtype==recvtype && sendcnt==recvcnt); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Gather(sendbuf,
 		 sendcnt,
@@ -250,5 +257,5 @@
 # endif
 #else
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -267,5 +274,5 @@
   assert(sendtype==recvtype); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Gatherv(sendbuf,
 		  sendcnt,
@@ -290,5 +297,5 @@
 #else
   assert(sendcnt==recvcnts[0]); // we handle only identical representations 
-# ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -304,12 +311,19 @@
 int ISSM_MPI_Init(int *argc, char ***argv){  /*{{{*/
 
-  int rc=0;
-#ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
-  rc=AMPI_Init_NT(argc,argv);
-# else
-  rc=MPI_Init(argc,argv);
-# endif
-#endif
+	int rc=0;
+	#ifdef _HAVE_MPI_
+		#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
+			#if defined(_HAVE_ADJOINTMPI_)
+				rc=AMPI_Init(argc,argv);
+			#elif defined(_HAVE_MEDIPACK_)
+				rc=AMPI_Init(argc,argv);
+				TOOL::init();
+			#else
+				rc=AMPI_Init_NT(argc,argv);
+			#endif
+		#else
+			rc=MPI_Init(argc,argv);
+		#endif
+	#endif
   return rc;
 }/*}}}*/
@@ -318,5 +332,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Recv(buf, 
 	       count,
@@ -324,5 +338,7 @@
 	       source,
 	       tag,
+			 #if !defined(_HAVE_ADJOINTMPI_) && !defined(_HAVE_MEDIPACK_)
 	       AMPI_FROM_SEND, // as long as there are no other variants
+			 #endif
 	       comm,
 	       status);
@@ -347,5 +363,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Reduce(sendbuf,
 		 recvbuf,
@@ -365,5 +381,5 @@
 # endif
 #else
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (datatype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -382,5 +398,5 @@
   assert(sendtype==recvtype && sendcnt==recvcnt); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Scatter(sendbuf,
 		  sendcnt,
@@ -402,5 +418,5 @@
 # endif
 #else
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)sendbuf;
@@ -419,5 +435,5 @@
   assert(sendtype==recvtype); // we handle only identical representations
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Scatterv(sendbuf,
 		   sendcnts,
@@ -442,5 +458,5 @@
 #else
   assert(sendcnts[0]==recvcnt); // we handle only identical representations 
-# ifdef _HAVE_ADOLC_
+# ifdef _HAVE_AD_
   if (sendtype==ISSM_MPI_DOUBLE) { 
     IssmDouble* activeSendBuf=(IssmDouble*)(sendbuf)+displs[0];
@@ -458,5 +474,5 @@
   int rc=0;
 #ifdef _HAVE_MPI_
-# ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
   rc=AMPI_Send(buf, 
 	       count,
@@ -464,5 +480,7 @@
 	       dest,
 	       tag,
+			 #if !defined(_HAVE_ADJOINTMPI_) && !defined(_HAVE_MEDIPACK_)
 	       AMPI_TO_RECV, // as long as there are no other variants
+			 #endif
 	       comm);
 # else
@@ -492,4 +510,6 @@
 #ifdef _HAVE_ADOLC_
   ensureContiguousLocations(aSize);
+#else
+  fprintf(stderr, "*** Codipack ISSM_MPI_ContiguousInAdolc()\n");
 #endif
 }/*}}}*/
@@ -498,5 +518,5 @@
 int rc=0;
 #ifdef _HAVE_MPI_
-#ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
 rc=MPI_Comm_split(comm, color, key, newcomm);
 #else
@@ -512,5 +532,5 @@
 	int rc=0;
 #ifdef _HAVE_MPI_
-#ifdef _HAVE_AMPI_
+#if defined(_HAVE_AMPI_) &&  !defined(_WRAPPERS_)
 	rc=MPI_Intercomm_create(comm,local_leader,peer_comm,remote_leader,tag,newintercomm);
 #else
Index: issm/trunk/src/c/toolkits/mpi/issmmpi.h
===================================================================
--- issm/trunk/src/c/toolkits/mpi/issmmpi.h	(revision 23389)
+++ issm/trunk/src/c/toolkits/mpi/issmmpi.h	(revision 23394)
@@ -16,8 +16,27 @@
 #include "../../shared/Numerics/types.h"
 
-#ifdef _HAVE_MPI_
+#if defined(_HAVE_MPI_)
 	/*Include header files: {{{*/
-	#ifdef _HAVE_AMPI_
-		#include <ampi/ampi.h>
+	#if defined(_HAVE_AMPI_) && !defined(_WRAPPERS_)
+		#if defined(_HAVE_ADJOINTMPI_)
+			#include <ampi_tape.hpp>
+
+		#elif defined(_HAVE_MEDIPACK_)
+			#include "medi/medi.hpp"
+			using namespace medi;
+			#include "medi/codiMediPackTypes.hpp"
+			#if defined(_HAVE_CODIPACK_)
+			#define TOOL CoDiPackTool<IssmDouble>
+			#define AMPI_ADOUBLE TOOL::MPI_TYPE
+			#elif defined(_HAVE_ADOLC_)
+			#include "adolc/medipacksupport.h"
+			#define TOOL AdolcTool
+			#else
+			#error "don't know about AD tool"
+			#endif
+
+		#else
+			#include <ampi/ampi.h>
+		#endif
 	#elif  _HAVE_PETSC_MPI_ // Petsc now hides there MPI header. It can be reached through Petsc.
 		#include <petsc.h>
@@ -27,31 +46,58 @@
 	/*}}}*/
 	/*MPI defines: *{{{*/
+
 	// types
+	#if defined(_HAVE_MEDIPACK_) && !defined(_WRAPPERS_)
+	typedef AMPI_Comm             ISSM_MPI_Comm;
+	typedef AMPI_Datatype         ISSM_MPI_Datatype;
+	typedef AMPI_Op               ISSM_MPI_Op;
+	typedef AMPI_Status           ISSM_MPI_Status;
+	#else
 	typedef MPI_Comm             ISSM_MPI_Comm;
 	typedef MPI_Datatype         ISSM_MPI_Datatype;
 	typedef MPI_Op               ISSM_MPI_Op;
 	typedef MPI_Status           ISSM_MPI_Status;
+	#endif
 
-	// data types
-	#define ISSM_MPI_CHAR       MPI_CHAR
-	#ifdef _HAVE_AMPI_
-		#define ISSM_MPI_DOUBLE    AMPI_ADOUBLE // corresponds to IssmDouble
-	#else 
-		#define ISSM_MPI_DOUBLE    MPI_DOUBLE  // corresponds to IssmDouble 
+	#if defined(_HAVE_MEDIPACK_) && !defined(_WRAPPERS_)
+	#define ISSM_MPI_CHAR       AMPI_CHAR
+	#define ISSM_MPI_DOUBLE     AMPI_ADOUBLE // corresponds to IssmDouble
+	#define ISSM_MPI_PDOUBLE    AMPI_DOUBLE  // corresponds to IssmPDouble
+	#define ISSM_MPI_INT        AMPI_INT
+	
+	// operations
+	#define ISSM_MPI_MAX        AMPI_MAX
+	#define ISSM_MPI_MIN        AMPI_MIN
+	#define ISSM_MPI_PROD       AMPI_PROD
+	#define ISSM_MPI_SUM        AMPI_SUM
+	
+	// others
+	#define ISSM_MPI_COMM_WORLD    AMPI_COMM_WORLD
+	#define ISSM_MPI_STATUS_IGNORE AMPI_STATUS_IGNORE
+	#define ISSM_MPI_ANY_TAG       AMPI_ANY_TAG
+	#define ISSM_MPI_ANY_SOURCE    AMPI_ANY_SOURCE
+
+	#else
+		#if defined(_HAVE_AMPI_) && !defined(_WRAPPERS_)
+			#define ISSM_MPI_DOUBLE    AMPI_ADOUBLE
+		#else 
+			#define ISSM_MPI_DOUBLE    MPI_DOUBLE
+		#endif
+		#define ISSM_MPI_PDOUBLE    MPI_DOUBLE
+		#define ISSM_MPI_INT        MPI_INT
+		#define ISSM_MPI_CHAR       MPI_CHAR
+
+		// operations
+		#define ISSM_MPI_MAX        MPI_MAX
+		#define ISSM_MPI_MIN        MPI_MIN
+		#define ISSM_MPI_PROD       MPI_PROD
+		#define ISSM_MPI_SUM        MPI_SUM
+
+		// others
+		#define ISSM_MPI_COMM_WORLD    MPI_COMM_WORLD
+		#define ISSM_MPI_STATUS_IGNORE MPI_STATUS_IGNORE
+		#define ISSM_MPI_ANY_TAG       MPI_ANY_TAG
+		#define ISSM_MPI_ANY_SOURCE    MPI_ANY_SOURCE
 	#endif
-	#define ISSM_MPI_PDOUBLE    MPI_DOUBLE  // corresponds to IssmPDouble
-	#define ISSM_MPI_INT        MPI_INT
-
-	// operations
-	#define ISSM_MPI_MAX        MPI_MAX
-	#define ISSM_MPI_MIN        MPI_MIN
-	#define ISSM_MPI_PROD       MPI_PROD
-	#define ISSM_MPI_SUM        MPI_SUM
-
-	// others
-	#define ISSM_MPI_COMM_WORLD    MPI_COMM_WORLD
-	#define ISSM_MPI_STATUS_IGNORE MPI_STATUS_IGNORE
-	#define ISSM_MPI_ANY_TAG       MPI_ANY_TAG
-	#define ISSM_MPI_ANY_SOURCE    MPI_ANY_SOURCE
 
     /*other include files: */
@@ -90,5 +136,5 @@
 template <class T> ISSM_MPI_Datatype TypeToMPIType(){assert(false);};
 template <> inline ISSM_MPI_Datatype TypeToMPIType<IssmDouble>(){return ISSM_MPI_DOUBLE;};
-#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_) 
+#if defined(_HAVE_AD_) && !defined(_WRAPPERS_) 
 template <> inline ISSM_MPI_Datatype TypeToMPIType<IssmPDouble>(){return ISSM_MPI_PDOUBLE;};
 #endif
Index: issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp
===================================================================
--- issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/mumps/MumpsSolve.cpp	(revision 23394)
@@ -18,4 +18,5 @@
 #include "../mpi/issmmpi.h"
 #include "../adolc/adolcincludes.h"
+#include "../codipack/codipackincludes.h"
 #include "../issm/SparseRow.h"
 #include "./mumpsincludes.h"
@@ -25,4 +26,9 @@
 
 void MumpsInit(DMUMPS_STRUC_C &theMumpsStruc){ 
+	theMumpsStruc.n = 0;
+	theMumpsStruc.nz = 0;
+	theMumpsStruc.a = NULL;
+	theMumpsStruc.jcn = NULL;
+	theMumpsStruc.irn = NULL;
 	theMumpsStruc.par          = 1;  
 	theMumpsStruc.sym          = 0;
@@ -98,5 +104,5 @@
 }
 
-#ifdef _HAVE_ADOLC_
+#ifdef _HAVE_AD_
 // prototype for active variant
 void MumpsSolve(int n,
@@ -354,6 +360,5 @@
 
 #ifdef _HAVE_ADOLC_
-
-int mumpsSolveEDF(int iArrLength, int* iArr, int /* ignored */, IssmPDouble* dp_x, int /* ignored */, IssmPDouble* dp_y) {
+int mumpsSolveEDF(int iArrLength, int* iArr, int /* ignored */, IssmPDouble* dp_x, int /* ignored */, IssmPDouble* dp_y){/*{{{*/
   // unpack parameters
   int n=iArr[0];
@@ -381,7 +386,6 @@
   xDelete(local_irn);
   return 0;
-}
-
-void MumpsSolve(int n,int nnz,int local_nnz,int* irn_loc,int* jcn_loc,IssmDouble *a_loc,IssmDouble *rhs,Parameters* parameters){
+}/*}}}*/
+void MumpsSolve(int n,int nnz,int local_nnz,int* irn_loc,int* jcn_loc,IssmDouble *a_loc,IssmDouble *rhs,Parameters* parameters){/*{{{*/
   int packedDimsSparseArrLength=1+1+1+local_nnz+local_nnz;
   int *packedDimsSparseArr=xNew<int>(packedDimsSparseArrLength);
@@ -425,10 +429,6 @@
   xDelete(pack_A_rhs);
   xDelete(packedDimsSparseArr);
-}
-
-int fos_reverse_mumpsSolveEDF(int iArrLength, int* iArr, 
-			      int m, IssmPDouble *dp_U,
-			      int nPlusNz, IssmPDouble *dp_Z,
-			      IssmPDouble *dp_x, IssmPDouble *dp_y) {
+}/*}}}*/
+int fos_reverse_mumpsSolveEDF(int iArrLength, int* iArr, int m, IssmPDouble *dp_U, int nPlusNz, IssmPDouble *dp_Z, IssmPDouble *dp_x, IssmPDouble *dp_y) {/*{{{*/
   // unpack parameters
   int n=iArr[0];
@@ -481,5 +481,168 @@
   xDelete(local_irn);
   return 3;
-}
-
-#endif
+}/*}}}*/
+#endif
+
+#ifdef _HAVE_CODIPACK_
+void MumpsSolve_codi_b(void* tape_in,void* data_in,void* ra) {/*{{{*/
+
+	/*recast data_in and tape*/
+  codi::DataStore* data = (codi::DataStore*)data_in;
+  //IssmDouble::TapeType& tape = (IssmDouble::TapeType&)tape_in;
+  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+
+
+  IssmDouble::Real* valueATrans;
+  IssmDouble::GradientData* indexATrans;
+  int* irnATrans;
+  int* jcnATrans;
+  IssmDouble::GradientData* indexB;
+  IssmDouble::Real* valueX;
+  IssmDouble::GradientData* indexX;
+  int n;
+  int nnz;
+  int local_nnz;
+  Parameters* parameters;
+
+  data->getData(valueATrans);
+  data->getData(indexATrans);
+  data->getData(irnATrans);
+  data->getData(jcnATrans);
+  data->getData(indexB);
+  data->getData(valueX);
+  data->getData(indexX);
+  data->getData(n);
+  data->getData(nnz);
+  data->getData(local_nnz);
+  data->getData(parameters);
+
+  // create the adjoint vector for x and reset the adjoint values on the tape
+  IssmDouble::GradientValue* adjX = xNew<IssmDouble::GradientValue>(n);
+  getVectorAdjoint(tape, indexX, adjX, n);
+
+  MumpsSolve(n, nnz, local_nnz, irnATrans, jcnATrans, valueATrans, adjX, parameters);
+  // adjX contains now the solution
+
+  updateVectorAdjoint(tape, indexB, adjX, n);
+
+  // bcast dp_y (the solution of the forward system)
+  ISSM_MPI_Bcast(valueX,n,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
+  // bcast the adjoint of the right-hand-side, i.e. this solution
+  ISSM_MPI_Bcast(adjX,n,ISSM_MPI_PDOUBLE,0,IssmComm::GetComm());
+
+  for(int i=0; i<local_nnz; ++i) {
+    // we access the transposed matrix here because we stored the indices in a transposed way
+    // -1 is substracted because jcn and irn are stored with fortran indexing
+    updateAdjoint(tape, indexATrans[i], -adjX[jcnATrans[i]-1]*valueX[irnATrans[i]-1]);
+  }
+
+  xDelete(adjX);
+}
+/*}}}*/
+void MumpsSolve_codi_delete(void* tape_in,void* data_in) {/*{{{*/
+
+	/*recast data_in*/
+	codi::DataStore* data = (codi::DataStore*)data_in;
+
+  IssmDouble::Real* valueATrans;
+  IssmDouble::GradientData* indexATrans;
+  int* irnATrans;
+  int* jcnATrans;
+  IssmDouble::GradientData* indexB;
+  IssmDouble::Real* valueX;
+  IssmDouble::GradientData* indexX;
+  int n;
+  int nnz;
+  int local_nnz;
+  Parameters* parameters;
+
+  data->getData(valueATrans);
+  data->getData(indexATrans);
+  data->getData(irnATrans);
+  data->getData(jcnATrans);
+  data->getData(indexB);
+  data->getData(valueX);
+  data->getData(indexX);
+  data->getData(n);
+  data->getData(nnz);
+  data->getData(local_nnz);
+  data->getData(parameters);
+
+  xDelete(valueATrans);
+  xDelete(indexATrans);
+  xDelete(irnATrans);
+  xDelete(jcnATrans);
+  xDelete(indexB);
+  xDelete(valueX);
+  xDelete(indexX);
+}
+/*}}}*/
+void MumpsSolve(int n,int nnz,int local_nnz,int* irn_loc,int* jcn_loc,IssmDouble *a_loc,IssmDouble *rhs,Parameters* parameters){/*{{{*/
+  IssmDouble::TapeType& tape = IssmDouble::getGlobalTape();
+  codi::DataStore* dataHandler = NULL;
+
+  if(tape.isActive()) {
+    dataHandler = new codi::DataStore();
+
+    // create the index and double vector for the matrix
+    IssmDouble::Real* valueATrans = xNew<IssmDouble::Real>(local_nnz);
+    IssmDouble::GradientData* indexATrans = xNew<IssmDouble::GradientData>(local_nnz);
+    int* irnATrans = xNew<int>(local_nnz);
+    int* jcnATrans = xNew<int>(local_nnz);
+
+    // read the data for the matrix A in a transposed fashion
+	  for (int i=0; i<local_nnz; ++i) {
+        getPrimalAndGradData(a_loc[i], valueATrans[i], indexATrans[i]);
+        irnATrans[i]=jcn_loc[i];  // transposed store
+        jcnATrans[i]=irn_loc[i];  // transposed store
+    }
+
+    // create the index vector for a (primal values are not needed for a)
+    IssmDouble::GradientData* indexB = xNew<IssmDouble::GradientData>(n);
+    getVectorGradData(rhs, indexB, n);
+
+    dataHandler->addData(valueATrans);
+    dataHandler->addData(indexATrans);
+    dataHandler->addData(irnATrans);
+    dataHandler->addData(jcnATrans);
+    dataHandler->addData(indexB);
+  }
+
+  // unpack the primal values from the matrix and the vector
+  IssmDouble::Real* valueA = xNew<IssmDouble::Real>(local_nnz);
+  IssmDouble::Real* valueB = xNew<IssmDouble::Real>(n);
+  // read the data from A and B
+  getVectorPrimal(a_loc, valueA, local_nnz);
+  getVectorPrimal(rhs, valueB, n);
+
+  MumpsSolve(n, nnz, local_nnz, irn_loc, jcn_loc, valueA, valueB, parameters);
+  // valueB contains now the solution
+
+  // pack the values into rhs
+  setVectorPrimal(rhs, valueB, n);
+
+  if(tape.isActive()) {
+    // create the index vector X and register x as active variables
+    IssmDouble::GradientData* indexX = xNew<IssmDouble::GradientData>(n);
+    registerVector(rhs, indexX, n);
+
+    dataHandler->addData(valueB); // contains the values from x
+    dataHandler->addData(indexX);
+
+    // store other arguments
+    dataHandler->addData(n);
+    dataHandler->addData(nnz);
+    dataHandler->addData(local_nnz);
+    dataHandler->addData(parameters); // we assume here that parameters is still intact when the reverse run is called
+
+	 //tape.pushExternalFunction(&MumpsSolve_codi_b, dataHandler, &MumpsSolve_codi_delete);
+    tape.pushExternalFunctionHandle(&MumpsSolve_codi_b,(void*)dataHandler, &MumpsSolve_codi_delete);
+  } else {
+    // if the tape is active valueB is stored in the dataHandler and deleted in the reverse sweep
+    xDelete(valueB);
+  }
+
+  xDelete(valueA);
+}
+/*}}}*/
+#endif
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 23394)
@@ -21,5 +21,5 @@
 PetscMat::PetscMat(){/*{{{*/
 	this->matrix=NULL;
-	#ifdef _HAVE_ADOLC_
+	#ifdef _HAVE_AD_
 	this->amatrix=NULL;
 	#endif
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 23389)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscMat.h	(revision 23394)
@@ -27,5 +27,5 @@
 		Mat matrix;
 
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
 		IssmDouble* amatrix;
 		#endif
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 23394)
@@ -15,4 +15,5 @@
 #include "../../../shared/io/Comm/IssmComm.h"
 #include "../../../shared/Enum/Enum.h"
+#include "../../../shared/io/Print/Print.h"
 
 void	PetscSolve(PetscVec** puf, PetscMat* Kff, PetscVec* pf, PetscVec* uf0,PetscVec* df, Parameters* parameters){ /*{{{*/
@@ -156,4 +157,5 @@
 	KSPGetIterationNumber(ksp,&iteration_number);
 	if (iteration_number<0) _error_("Solver diverged at iteration number: " << -iteration_number);
+	if (VerboseSolver())  _printf0_("Petsc: "<< iteration_number << " KSP iterations\n"); 
 
 	/*Free resources:*/
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 23389)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 23394)
@@ -21,5 +21,5 @@
 PetscVec::PetscVec(){/*{{{*/
 	this->vector=NULL;
-	#ifdef _HAVE_ADOLC_
+	#ifdef _HAVE_AD_
 	this->avector=NULL;
 	#endif
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 23389)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.h	(revision 23394)
@@ -25,5 +25,5 @@
 		Vec vector;
 
-		#ifdef _HAVE_ADOLC_
+		#ifdef _HAVE_AD_
 		IssmDouble* avector;
 		#endif
Index: issm/trunk/src/c/toolkits/toolkits.h
===================================================================
--- issm/trunk/src/c/toolkits/toolkits.h	(revision 23389)
+++ issm/trunk/src/c/toolkits/toolkits.h	(revision 23394)
@@ -30,4 +30,8 @@
 #endif
 
+#ifdef _HAVE_CODIPACK_
+#include "./codipack/codipackincludes.h"
+#endif
+
 #ifdef _HAVE_TRIANGLE_
 #include "./triangle/triangleincludes.h"
Index: issm/trunk/src/m/classes/SMBgradientscomponents.m
===================================================================
--- issm/trunk/src/m/classes/SMBgradientscomponents.m	(revision 23394)
+++ issm/trunk/src/m/classes/SMBgradientscomponents.m	(revision 23394)
@@ -0,0 +1,90 @@
+%SMBgradientscomponents Class definition
+%
+%   Usage:
+%      SMBgradientscomponents=SMBgradientscomponents();
+
+classdef SMBgradientscomponents
+	properties (SetAccess=public)
+		accuref					  = NaN;
+		accualti				  = NaN;
+		accugrad				  = NaN;
+		runoffref				  = NaN;
+		runoffalti			  = NaN;
+		runoffgrad			  = NaN;
+		requested_outputs = {};
+	end
+	methods
+		function self=SMBgradientscomponents(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+
+		function self = extrude(self,md) % {{{
+
+		%Nothing for now
+
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+			list = {'runoff'};
+		end % }}}
+		function self = initialize(self,md) % {{{
+
+		%Nothing done for now
+
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+
+		%Nothing for now
+
+		end % }}}
+		function	md=checkconsistency(self,md,solution,analyses) % {{{
+			if ismember('MasstransportAnalysis',analyses),
+				md = checkfield(md,'fieldname','smb.accuref','timeseries',1,'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','smb.accualti','numel',1,'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','smb.accugrad','numel',1,'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','smb.runoffref','timeseries',1,'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','smb.runoffalti','numel',1,'NaN',1,'Inf',1);
+				md = checkfield(md,'fieldname','smb.runoffgrad','numel',1,'NaN',1,'Inf',1);
+			end
+			md = checkfield(md,'fieldname','masstransport.requested_outputs','stringrow',1);
+		end % }}}
+
+		function disp(self) % {{{
+			disp(sprintf('   surface forcings parameters:'));
+			disp(sprintf('\n   SMB gradients components parameters:'));
+			fielddisplay(self,'accuref',' reference value of the accumulation');
+			fielddisplay(self,'accualti',' Altitude at which the accumulation is equal to the reference value');
+			fielddisplay(self,'accugrad',' Gradient of the variation of the accumulation (0 for uniform accumulation)');
+			fielddisplay(self,'runoffref',' reference value of the runoff m w.e. y-1 (temperature times ddf)');
+			fielddisplay(self,'runoffalti',' Altitude at which the runoff is equal to the reference value');
+			fielddisplay(self,'runoffgrad',' Gradient of the variation of the runoff (0 for uniform runoff) m w.e. m-1 y-1 (lpase rate times ddf)');
+			fielddisplay(self,'requested_outputs','additional outputs requested');
+
+		end % }}}
+		function marshall(self,prefix,md,fid)    % {{{
+
+			WriteData(fid,prefix,'name','md.smb.model','data',11,'format','Integer');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','accuref','format','DoubleMat','mattype',1,'timeserieslength',2,'yts',md.constants.yts,'scale',1./md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','accualti','format','Double');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','accugrad','format','Double','scale',1./md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffref','format','DoubleMat','mattype',1,'timeserieslength',2,'yts',md.constants.yts,'scale',1./md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffalti','format','Double');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','runoffgrad', ...
+								'format','Double','scale',1./md.constants.yts);
+
+			%process requested outputs
+			outputs = self.requested_outputs;
+			pos  = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = [];                         %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.smb.requested_outputs','format','StringArray');
+
+		end % }}}
+	end
+end
